Implement a notification area in Docky

Bug #391056 reported by Andrea Cimitan
340
This bug affects 69 people
Affects Status Importance Assigned to Milestone
Do
Wishlist
Unassigned
Declined for 0.9 by Alex Launi
Docky
Wishlist
Robert Dyer

Bug Description

The summary explains itself: docky needs a notification area docklet.

Revision history for this message
Robert Dyer (psybers) wrote :

The GNOME term for this is notification area, and we are all aware of a need for this. Actually implementing this is quite a task however and somewhat low on our priority list.

Changed in do:
importance: Undecided → Wishlist
status: New → Confirmed
summary: - Implement system tray in docky
+ Implement a notification area in Docky
tags: added: docky
description: updated
Revision history for this message
The Fiddler (stapostol) wrote :

Notification area specs: http://standards.freedesktop.org/systemtray-spec/latest/

They don't seem terribly complicated, although there are a lot of things to care of (from tray orientation to baloon pop ups). I may try my hand at this in a couple of weeks.

To avoid duplication of effort, are there any current thoughts or work on an implementation? Any hints on how it should work?

Revision history for this message
Robert Dyer (psybers) wrote :

As far as I know there is no current work being done on this. I do however have an idea as to how I would like it to work. Thus if you want to collaborate with me I would be more than happy to help implement this. The first step is producing code to handle all the tray messages, get the icons, successfully show *any* bubble, etc. If you can get that far I can easily take that and make a very nice docklet. :-)

Feel free to email me or stop by IRC (my username is PsyberS).

Revision history for this message
Aleksander Sumowski (sumek) wrote :

If docky had a notification area, I would be able to get rid of the gnome panels altogether :)

Revision history for this message
The Fiddler (stapostol) wrote : Re: [Bug 391056] Re: Implement a notification area in Docky

I'm having exams for another tenday, but I'll try my hand after that.

Revision history for this message
Sandy Armstrong (sanfordarmstrong) wrote :

I've suggested that bug #324702 be marked as a duplicate of this bug.

Revision history for this message
Krzysztof Kotlenga (pocek) wrote :

You might want to know that, thanks to GAPI [1], it's very easy to wrap gnome-panel's notification area widget [2] and reuse it. I've actually done that as part of my rather lame pet project (not yet related with gnome-do) [3]. It seems quite solid and probably better than reinventing the wheel (and a dead spec; see the latest KDE work in this area).

[1] http://mono-project.com/GAPI
[2] http://git.gnome.org/cgit/gnome-panel/tree/applets/notification_area
[3] http://kotlenga.name/hg/do-interface-kiss/file/tip/tray

Revision history for this message
Sandy Armstrong (sanfordarmstrong) wrote :

On Sat, Aug 15, 2009 at 5:48 AM, Krzysztof Kotlenga<email address hidden> wrote:
> You might want to know that, thanks to GAPI [1], it's very easy to wrap
> gnome-panel's notification area widget [2] and reuse it.

Except that I don't think embedding a gtk widget in Docky would be very elegant.

Revision history for this message
Robert Dyer (psybers) wrote :

I'm with Sandy here. Embedding that widget is definitely *not* the way to go for Docky. If/when Docky supports notification areas, it will be a custom design.

Revision history for this message
Linus Sjögren (thelinx-deactivatedaccount-deactivatedaccount-deactivatedaccount-deactivatedaccount-deactivatedaccount) wrote :

I'm just gonna post here to say that I'd really like a notification area docklet since that would mean I could scrap gnome-panel forever.

Please consider doing this some time soon.

Revision history for this message
Daniel Skinner (dasacc22) wrote :

+1 to a notification area

using intellihide for docky pretty much renders any standalone notification area that much more useless. gotta show desktop first.

+1 to a custom design

comments aside, its the right thing to do for do.

Wish I knew C#, this is something i want bad enough id love to invest my time into it but id lack the foresight for a proper design with C#.

Revision history for this message
alejaaandro (alejaaandro) wrote :

just want to second this.. i use docky on my desktop along with a panel on the top, just for the notifications..

but on my netbook, space is limited so, in order to get rid of the panel i have to use awn, which i don't really like (it's autohide behavior really sucks), as opposed to docky's.. i still have gnome-do in the netbook so i can lunch apps..

has any progress been made? i'd be more than glad to test, unfortunately i have no C skills..

Revision history for this message
Marc Boivin (marcboivin) wrote :

+1 for notification area. Docky seems like a natural replacement for the gnome panel. It's only missing the notification area.

Revision history for this message
Till Hartmann (tillux) wrote :

I agree. The only thing I feel is missing in gnome-do is a notification area. There are several ways in which they could be integrated into the ui/look'n'feel of docky, either by using the 16x16px icons and placing them in a grid/table of some rows and columns or by looking up the application "behind" the trayIcon and get an icon for that app.
Or (maybe as an option) only display applications which need attention.
I could also imagine mergin the application-indicators with the notification area functionality, e.g. for rhythmbox / pidgin / skype etc...

Revision history for this message
Robert Dyer (psybers) wrote :

Please DO NOT add 'docky' to existing Do bugs! At some point, we will MOVE the bugs over! We do not need both projects listed in every bug report.

Changed in do:
status: Confirmed → Won't Fix
Changed in docky:
importance: Undecided → Wishlist
Robert Dyer (psybers)
Changed in docky:
assignee: nobody → Robert Dyer (psybers)
Robert Dyer (psybers)
tags: removed: docky
Robert Dyer (psybers)
Changed in docky:
status: New → Confirmed
Revision history for this message
Aryan Ameri (aameri) wrote :

Just adding in my two cents. Adding notification area to Docky would make bring it it very close to completely replacing panels. I'm using the the docky PPA on Karmic, and from a "I won't ever touch anything that resembles an OS X Dock", I've gone to "I'm absolutely loving this. So freaking awesome". Thanks a lot all docky developers, keep up the very impressive job. It's great to see you care about your users wishlists.

Revision history for this message
Anonym25712 (anonym25712) wrote :

One more "me too": Seeing tray icons is the only thing that I really miss in Docky. I got rid of gnome-panel in favor of Docky, and I currently have to use stalonetray for tray icons, but this program always behave strangely (half of the time, it appears in a wrong place of my desktop). Getting rid of it would be so cool...

Revision history for this message
Cyberkilla (cyberkilla04uk-deactivatedaccount) wrote :

Whilst I agree that notification area would be great, I have some reservations about the manner in which it would be displayed.

I see a couple of docks using atrocious boxes of blurred notification icons, with buggy right-click context menus that sometimes won't even close when they lose focus.

What I was thinking was, in the same way that you display the weather and calendar, could you /potentially/ do the same for the notification icons?

For instance, you'd have a useful - but unintrusive - single docklet icon...
When you click on the icon, the tray icons would slide in, just as the weather forecast does.

Revision history for this message
Andrea Cimitan (cimi) wrote :

2009/11/30 Cyberkilla <email address hidden>:
> Whilst I agree that notification area would be great, I have some
> reservations about the manner in which it would be displayed.
>
> I see a couple of docks using atrocious boxes of blurred notification
> icons, with buggy right-click context menus that sometimes won't even
> close when they lose focus.
>
> What I was thinking was, in the same way that you display the weather
> and calendar, could you /potentially/ do the same for the notification
> icons?
>
> For instance, you'd have a useful - but unintrusive - single docklet icon...
> When you click on the icon, the tray icons would slide in, just as the weather forecast does.
>
The purpose of notification area icons is to have them always visible,
if you hide them then they become useless :)
--
Andrea Cimitan - http://www.cimitan.com

Revision history for this message
Felipe Morales (hel-sheep) wrote :

I like Cyberkilla's idea, but I think one has to consider two things:
a) The size of the icons. Tray apps icons tend to make sense only when small. This seems to me due to
b) The tray is a notification area (as Andrea Cimitan pointed). There must be some way of highlighting apps which need it. Apps should appear in the tray, on demand, not necessarily always. For example, right now, I have a volume tray app, a clipboard manager, and a mail agent in the tray. Of those, the volume and clipboard ones I'm not using very often, and there's no need of them showing all the time. Neither does the mail icon have to be there all the time: it's useful only when I have a new mail.
Maybe, in some scenario like Cyberkilla's, highlighted apps could appear alongside the main tray button, or maybe the button could appear highlighted and the behaviour could change to "Activate notifying app when pressed" instead of "Show tray icons when pressed" (against, I know, the principle of least surprise).
Just my two cents.

Revision history for this message
Anonym25712 (anonym25712) wrote :

> I see a couple of docks using atrocious boxes of blurred notification
> icons, with buggy right-click context menus that sometimes won't
> even close when they lose focus.

The blurry icons surely come from the associated program, which does not ship with the rightly sized icons. If the tray is correctly implemented, the application is notified when the size of the notification area changes, and it's up to that application to replace its tray icon by a more adapted one. If the application doesn't do that, then it must be patched, but in any case the problem is not caused by the dock or any other tray mechanism. And if it's correctly implemented, there should not be any problem with popup menus :-)

Revision history for this message
Cyberkilla (cyberkilla04uk-deactivatedaccount) wrote :

@Andrea Cimitan: I see your point. :-)

Would handy if you could hide some of them. I really dislike seeing nm-applet and volume in my notification area. They aren't even notifications! It's just a hack from GNOME because they don't have a proper place for them to live, IMHO.

Revision history for this message
The Fiddler (stapostol) wrote :

On Mon, 2009-11-30 at 13:10 +0000, Andrea Cimitan wrote:
> 2009/11/30 Cyberkilla <email address hidden>:
> >
> > For instance, you'd have a useful - but unintrusive - single docklet icon...
> > When you click on the icon, the tray icons would slide in, just as the weather forecast does.
> >
> The purpose of notification area icons is to have them always visible,
> if you hide them then they become useless :)

Well, the notification area has been consistently abused and has moved
from the original concept (transient notifications) to an
easy-to-implement, cross-DE panel integration area. For example,
applications like Banshee, Rythmbox, Transmission, etc do *not* belong
to the notification area - yet there they are. (Email notifications on
the other hand, do).

Andrea's idea is very similar to the approach taken by Windows 7, which
works surprisingly well (there, I said it!) Windows has always had the
"tray icon proliferation" issue that has started to affect our
notification areas. Their solution was to add a single "notification
button" to their dock (sorry, taskbar), which displays notifications in
a pop-up bubble once clicked. The user can also configure notifications
as "always visible" (outside the bubble) or "always hidden" (inside the
bubble).

For the shake of discussion, I'd propose a similar system only taken one
step further: notifications demanding attention should be promoted from
the bubble onto docky automatically. Everything else should appear
either in the bubble or onto docky, depending on a per-icon preference
(default is in the bubble, except for specific important icons like
battery or network manager).

How does this sound? I can provide mockup screenshots if necessary.

Revision history for this message
Daniel Skinner (dasacc22) wrote :

im not quite sure if this is what you were hitting on, but half way through
reading, I thought it would at least be useful to make items that normally
skip the taskbar, simply not. Then they would at least display in docky and
you can organize them to the right or wherever.

Kinda like a quick fix instead of using stalonetray (which i find to always
be a little buggy)

On Mon, Nov 30, 2009 at 8:56 AM, The Fiddler <email address hidden> wrote:

> On Mon, 2009-11-30 at 13:10 +0000, Andrea Cimitan wrote:
> > 2009/11/30 Cyberkilla <email address hidden>:
> > >
> > > For instance, you'd have a useful - but unintrusive - single docklet
> icon...
> > > When you click on the icon, the tray icons would slide in, just as the
> weather forecast does.
> > >
> > The purpose of notification area icons is to have them always visible,
> > if you hide them then they become useless :)
>
> Well, the notification area has been consistently abused and has moved
> from the original concept (transient notifications) to an
> easy-to-implement, cross-DE panel integration area. For example,
> applications like Banshee, Rythmbox, Transmission, etc do *not* belong
> to the notification area - yet there they are. (Email notifications on
> the other hand, do).
>
> Andrea's idea is very similar to the approach taken by Windows 7, which
> works surprisingly well (there, I said it!) Windows has always had the
> "tray icon proliferation" issue that has started to affect our
> notification areas. Their solution was to add a single "notification
> button" to their dock (sorry, taskbar), which displays notifications in
> a pop-up bubble once clicked. The user can also configure notifications
> as "always visible" (outside the bubble) or "always hidden" (inside the
> bubble).
>
> For the shake of discussion, I'd propose a similar system only taken one
> step further: notifications demanding attention should be promoted from
> the bubble onto docky automatically. Everything else should appear
> either in the bubble or onto docky, depending on a per-icon preference
> (default is in the bubble, except for specific important icons like
> battery or network manager).
>
> How does this sound? I can provide mockup screenshots if necessary.
>
> --
> Implement a notification area in Docky
> https://bugs.launchpad.net/bugs/391056
> You received this bug notification because you are a direct subscriber
> of the bug.
>
> Status in GNOME Do: Won't Fix
> Status in Docky: Confirmed
>
> Bug description:
> The summary explains itself: docky needs a notification area docklet.
>

Revision history for this message
Cyberkilla (cyberkilla04uk-deactivatedaccount) wrote :

@Felipe Morales: The idea is that the applications that have a tray icon will hide it when there is nothing to notify you about. Unfortunately, that doesn't happen in many cases. It seems to be the stance of GNOME that they will not hide any third-party sins. If your icon is annoying, change it, or face a backlash from users... Their philosophy doesn't seem to work though; there are tons of awful tray icons out there!

For me, this problem is further aggravated by GNOME using the Notification Area to host the Volume, Battery and Network icons. In Vista, these are shown next to the tray, but they aren't really part of it (afaik). Instead, they can be toggled on/off.

The only way you can hide the GNOME volume/network icons is to kill the process.

@François Ingelrest: That's good to know. ;-)

From my own experience, most icons look fine when gnome-panel is set to 24px high. Any bigger or smaller and some of the icons behave oddly.

Some will scale up smoothly. Some will scale up, but become blurred. Some won't change size at all.

As long as the default dimensions of gnome-panel are used, it will probably be okay.

Revision history for this message
Cyberkilla (cyberkilla04uk-deactivatedaccount) wrote :

@The Fiddler: I completely agree. It does work well. If you could relegate some of the less useful icons to an expanded view, displaying only the important ones in the docklet icon, it would be perfect.

Revision history for this message
Till Hartmann (tillux) wrote :

On 30.11.2009 13:56, Cyberkilla wrote:
> Whilst I agree that notification area would be great, I have some
> reservations about the manner in which it would be displayed.
>
> I see a couple of docks using atrocious boxes of blurred notification
> icons, with buggy right-click context menus that sometimes won't even
> close when they lose focus.
>
> What I was thinking was, in the same way that you display the weather
> and calendar, could you /potentially/ do the same for the notification
> icons?
>
> For instance, you'd have a useful - but unintrusive - single docklet icon...
> When you click on the icon, the tray icons would slide in, just as the weather forecast does.
>
>
The weather and calendar way of displaying their information might be a
good solution for some applications; but it might be better to integrate
dock- and trayicons, take rhythmbox as an example: if it's minimized the
icon's status indicator in docky will show up and, with the correct
plugins enabled, you can easily control it via the icons
right-click/contextmenu. If it's minimized to tray, it wont'.
Rhythmbox is one of the best examples (though only possible with a
plugin) of applications that violate the idea of a notification area.
Its idea is not to control applications via a context-menu (at least not
in the most cases) but rather displaying (important) news to the user,
such as available updates, new mail, some alarm etc. .
What I think might be a good idea is to provide a merged dock- and
trayicon for applications that support it AND an area for notifications
directly in the dock, aswell as a single docklet which will display all
tray icons in a weather-docklet manner (and allows interacting?). This
might sound too much, and perhaps this is true, but it might be worth a try.
Another (I think) very important aspect is the possibility to configure
it to one's needs (there should of course be a default configuration
which suits most of the users); (Just look at the windows 7
panel/notification area, which allows different options for different
applications, see #23 by The Fiddler).

Revision history for this message
alejaaandro (alejaaandro) wrote :

that sounds great.. and it would be even better if it could integrate with
ubuntu's notifications which are really slick

alejaaandro

Revision history for this message
Jakub 'Livio' Rusinek (liviopl-pl) wrote :

Notification area has nothing to do with system notifications from developer's point of view. Question of apps, not GNOME Do.

Revision history for this message
Alessio Biancalana (dottorblaster) wrote :

Kudos!

Revision history for this message
Gerry (gerry-spm+lnchpad) wrote :

+1 For this being this most important feature that Gnome Do could implement from my POV.

Revision history for this message
semon (simon-renard) wrote :

this would be very useful to have that in docky. Awn 4 implemented it and I think it is well done. This will allow to run a full panel less desktop.

Revision history for this message
joker806 (joker806) wrote :

Hi.. I was really looking forward for this feature, but no one posted any news for a long time.. so I decided to try implement it as my school work. It should be just simple notification area (like in Gnome panel), but I hope it will be somehow usable :)

Revision history for this message
alejaaandro (alejaaandro) wrote :

that's good news..

unfortunately, i can only help with testing if you want..

On Tue, Mar 16, 2010 at 11:04 PM, joker806 <email address hidden> wrote:

> Hi.. I was really looking forward for this feature, but no one posted
> any news for a long time.. so I decided to try implement it as my school
> work. It should be just simple notification area (like in Gnome panel),
> but I hope it will be somehow usable :)
>
> --
> Implement a notification area in Docky
> https://bugs.launchpad.net/bugs/391056
> You received this bug notification because you are a direct subscriber
> of the bug.
>
>

Revision history for this message
Adamek Zoltán :: scorchio (djscorchio) wrote :

Hi,
I'm happy to see this conversation about the notification area.
It's really a feature to add and while I can understand and appreciate that everyone has own design ideas, I would be kinda happy even with a _simple_ notification area.
By any means, I'm a bit far from being a professional developer (yet!), but... It might be wise to implement a rough and simple version for first. It would make easier to see everyone's point and it could start some talking about this feature. After that you could gather all the necessary resources to implement it as good as it can be.

[I would be really happy if anyone would spend his/her precious work hours on producing this, so if I could help someone out, contact me and we will see what can I do for you. I have quite limited knowledge and resources, but I'm interested...]

Revision history for this message
oKtosiTe (oktosite) wrote :

This would be terribly appreciated.

Revision history for this message
Julien-Charles Lévesque (jclevesque) wrote :

What about the new indicators introduced in Ubuntu 10.04 ? This could get quite complicated.

Revision history for this message
zpletan (zpletan) wrote :

@JC, actually, since AppIndicators are so uniform and consistent, that ought to make it easier, as Docky will now not have to support all kinds of obscure scenarios. This will only cause problems and be complicated with those things that use the (soon-to-be) legacy notification area.

Revision history for this message
Naftuli Kay (naftulikay) wrote :

I vote for this as well. This is THE main reason I stick with AWN, but I am ready to change!

Revision history for this message
Robert Dyer (psybers) wrote :

I might as well mark this WontFix, because quite frankly the notification area is going away. Apps are (slowly) replacing that functionality with the new indicator functionality. Soon there won't be a need for the notification area and thus we will not put effort into making such a docklet.

Revision history for this message
Felipe Morales (hel-sheep) wrote :

But, will you try then to develop a indicators-compatible docklet?

Revision history for this message
Robert Dyer (psybers) wrote :

@Felipe: that is a different bug, and we plan to.

Revision history for this message
Ward Muylaert (ward-muylaert) wrote :

Then I'd say, close this discussion and put a link to the one about indicator applet in the last post you make on this :P

Revision history for this message
Kangarooo Jānis (kangarooo) wrote :

This still isnt fixed..
and becouse of one programm has been made for ubuntu doesnt mean that notification area isnt needed for xubuntu and kubuntu users.
also ubuntu users would like to have notification area in docky.

Revision history for this message
Abdusamed Ahmed (sir508) wrote :

Notification is really annoying, I usually miss a friend reply on Pidgin. It only jumps once and has a blue dot which can't be seen most of time if viewing something fullscreen and docky hidden.

Revision history for this message
Matthew Woerly (nattgew) wrote :

I normally don't need a notification area, but it's nice to have it for wireless since the nm-applet is more functional than Docky's applet.

Revision history for this message
Thierry Frenkel (theremin-tfrenkel) wrote :

Nattgew is right... the network docklet is really missing lots of functionality compared to the nm-applet (same thing for the CPU docklet which can't really compete with indicator-cpufreq). I filed this several times at various places but docky developers seem to be still too much occupied with the docky core so that the docklets remain somewhat orphaned in terms of number and functionality... :-(

See also Bug #450730 (View folders as "Stacks") which has Wishlist status since october, 2009...

Revision history for this message
Robert Dyer (psybers) wrote :

We've gone on record stating we will not implement a notification area docklet. The community is free to do so.

Also regarding stacks, we have a branch and that is pretty much done. But there are some awful leaks from us using GIO and it's not quite ready to merge in yet.

Revision history for this message
Daniel Beauyat (dan-beauyat) wrote :

+1 for notification area.
very important; don't want to launch another dock app just to have tray/indicator support. I don't want to be forced to use Unity.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Related questions